;-------------------------------------------------------------------------------
; MSP430 Assembler Code Template for use with TI Code Composer Studio
;
;
;-------------------------------------------------------------------------------
            .cdecls C,LIST,"msp430.h"       ; Include device header file
;-------------------------------------------------------------------------------
            .data
a:			.byte	3, 6, 3, 1, 3, 6, 0, 3, 0, 3

;-------------------------------------------------------------------------------
            .text                           ; Assemble into program memory
            .retain                         ; Override ELF conditional linking
                                            ; and retain current section
            .retainrefs                     ; Additionally retain any sections
                                            ; that have references to current
                                            ; section
;-------------------------------------------------------------------------------
RESET       mov.w   #__STACK_END,SP         ; Initialize stackpointer
StopWDT     mov.w   #WDTPW|WDTHOLD,&WDTCTL  ; Stop watchdog timer

;-------------------------------------------------------------------------------
                                            ; Main loop here
; create 3 word length local variables on the stack

    		sub.w	#6, SP			; set aside space for 3 words on the stack
    		mov.w	#0, 0(SP)		; initialize count3
    		mov.w	#0, 2(SP)		; initialize count2
    		mov.w	#0, 4(SP)		; initialize count1

;--------------- for-loop (alternate implementation)----------------------------
			mov.w	#0, R5			; i = 0
for_cond:
			cmp.w	#10, R5			; (i >= 10) = ~(i<10)
			jge		for_break

;--------------- switch-case structure -----------------------------------------

			cmp.b	#3, a(R5)
			jeq		stuff1_label

			cmp.b	#6, a(R5)
			jeq		stuff2_label

			inc.w	0(SP)			; defaultstuff
			jmp		switch_break

stuff2_label:
			inc.w	2(SP)
			jmp		switch_break
stuff1_label:
			inc.w	4(SP)
switch_break:

;--------------- switch-case structure end -------------------------------------

			inc.w	R5
			jmp 	for_cond
for_break:
;--------------- for-loop end---------------------------------------------------
			add.w	#6, SP			; release space for 3 words from the stack

loop:		jmp	loop

;-------------------------------------------------------------------------------


;-------------------------------------------------------------------------------
;           Stack Pointer definition
;-------------------------------------------------------------------------------
            .global __STACK_END
            .sect 	.stack

;-------------------------------------------------------------------------------
;           Interrupt Vectors
;-------------------------------------------------------------------------------
            .sect   ".reset"                ; MSP430 RESET Vector
            .short  RESET
